;***************************************************************************
;
;       Ferienspiele 2010 
;       
;
;       D. Galle, Dipl.- Ing. 
;
;       File: Reaktion.asm         Date: 14.05.2010
;	
;
;       
;
 	 LIST    P=16F627A,N=55,F=INHX8M,R=D      
  

     	 INCLUDE "p16F627A.INC"
;
;            DCBA9876543210
  __CONFIG B'10000100110000'    	; 627, int osz, WDT OFF, brown out Off, PWT On, MCLRE On, LVP Off, CPD Off 
									
			      			      				
;
;
PGN     equ     '1'     		; Programm-Nummer
PGN_SUB equ     '0'     		; Subkennung
;
;
FSR     equ     4               ; Adresszeiger
 RA     equ     5               ; Port A
 IOPA   equ     B'00000'        ; Tris RA Grundeinstellung
 RAW    equ     B'00000'        ; Ausgangsmuster
 SegL	equ		0				; linkes Segment
 SegR	equ		1				; rechtes Segment

;
 RB     equ     6               ; Port B
 IOPB   equ     B'10000000'     ; Tris RB Grundeinstellung
 RBW    equ     B'00000000'     ; Ausgangsmuster

     
CMCON   equ     01FH          	; Init Komparatoren
CMCONW  equ     B'00000111'   	; Komparatoren Aus 
;

				;  edfgabc
Z0		equ		B'01110111'
Z1		equ		B'00000011'
Z2		equ		B'01101110'
Z3		equ		B'00101111'
Z4		equ		B'00011011'
Z5		equ		B'00111101'
Z6		equ		B'01111101'
Z7		equ		B'00000111'
Z8		equ		B'01111111'
Z9		equ		B'00111111'
ZF		equ		b'01011100'
ZBlank  equ		b'00000000'
Zn		equ		b'01001001'
Zo		equ		b'01101001'
ZStrich	equ		B'00001000'
Zg		equ		b'01110101'




#define Taster	PORTB,7	
#define Delay Flag,1

Temp0   equ     20H     		; Hilfsregister
Temp1   equ     21H     		; 
Temp2   equ     22H
Temp3   equ     23H
;
WSAV    equ		24H		        ; Arbeitsregister
STATSAV equ		25H		        ; retten
ZifferL equ		26H
ZifferR equ		27H
Count	equ		28H
Count10 equ		29H
Flag	equ		2AH
Sek_timer equ	2BH
Int_Count equ	2CH
Int_Work  equ	2DH
Random	equ		2EH
Multiplex equ	2FH

;
BANK_0	MACRO
	BCF	STATUS,6
	BCF	STATUS,5
	ENDM

BANK_1	MACRO
	BCF	STATUS,6
	BSF	STATUS,5
	ENDM

BANK_2	MACRO
	BSF	STATUS,6
	BCF	STATUS,5
	ENDM

BANK_3	MACRO
	BSF	STATUS,6
	BSF	STATUS,5
	ENDM

;
;******************************************************
;
	org     0
	Nop
    goto    Begin

;



;******************************************************
;       
;       Interrupt-Routinen
; 
	org     4

    movwf   WSAV            ; Arbeitsregister
	movf    STATUS,W        ; & Prozessorstatus
	movwf   STATSAV         ; retten
	
	bcf		INTCON,T0IE		; Timer0 Interrupt disabled
	clrf    INTCON          ; Interrupt Ende
	bsf		INTCON,T0IF		; Interrupt Flag lschen
	incf	Random
	incf	Sek_timer
	movf	Sek_timer,w
	movwf	Int_Work
	movf	Int_Count,w
	subwf	Int_Work
	BNZ		Run_Flag_nicht_Setzen	
	BSF		Flag,1
	clrf	Sek_timer
Run_Flag_nicht_Setzen
	incf	Multiplex
	btfsc	Multiplex,0
	goto	Ziffer_rechts
	bcf		PORTA,SegR
	movfw	ZifferL
	movwf	PORTB
	bsf		PORTA,SegL
	goto	INTEND
Ziffer_rechts
	bcf		PORTA,SegL
	movfw	ZifferR
	movwf	PORTB
	bsf		PORTA,SegR



;
INTEND

  	clrf    INTCON          ; Interrupt Ende
	bsf		INTCON,T0IE		; Timer0 Interrupt enabled
	movf    STATSAV,W       ; gerettete Register
	movwf   STATUS          ; wiederherstellen
	swapf   WSAV            ; Damit sich das Statusregister
	swapf   WSAV,W          ; nicht aendert

	retfie                  ; zurueck


;************************************************
;     Tabelle der Zahlen 0- 9
Table_10
	addwf	PCL
				;  edfgabc
	retlw		B'01110111'
	retlw		B'00000011'
	retlw		B'01101110'
	retlw		B'00101111'
	retlw		B'00011011'
	retlw		B'00111101'
	retlw		B'01111101'
	retlw		B'00000111'
	retlw		B'01111111'
	retlw		B'00111111'

;************************************************
;		Tabelle Segment- Test
Table_Segment_Test
	addwf	PCL
				;  edfgabc
	retlw		B'00001000'
	retlw		B'00000000'

	retlw		B'00000000'
	retlw		B'00001000'

	retlw		B'00000000'
	retlw		B'00000001'

	retlw		B'00000000'
	retlw		B'00100000'

	retlw		B'00100000'
	retlw		B'00000000'

	retlw		B'01000000'
	retlw		B'00000000'

	retlw		B'00001000'
	retlw		B'00000000'	

	retlw		B'00000000'
	retlw		B'00001000'

	retlw		B'00000000'
	retlw		B'00000010'

	retlw		B'00000000'
	retlw		B'00000100'

	retlw		B'00000100'
	retlw		B'00000000'

	retlw		B'00010000'
	retlw		B'00000000'

	retlw		B'00100000'
	retlw		B'00000000'

	retlw		B'00100000'
	retlw		B'00000000'

;
;******************************************************
;        
	data    ' ','D','G',' ',PGN,PGN_SUB
;
;******************************************************



;
;
;       Programmanfang
;
Begin

	BANK_0
	clrf	PORTA
	BANK_1
	movlw   IOPA    ; Ein-/Ausgaenge initialisieren
	movwf	TRISA
	movlw   IOPB
	movwf	TRISB
	BANK_0
	movlw	CMCONW
	movwf	CMCON	; Komparatoren ausschalten
	movlw   RAW
	movwf   PORTA              ;        
	movlw   RBW
	movwf   PORTB              ;

; 
;Timer0
;
	BANK_2
	clrf	TMR0
	BANK_1
	movlw	b'01010010'
	movwf	OPTION_REG

	BANK_0
       
	clrf    Temp0    ; Register auf Null setzen
	clrf    Temp1
	clrf    Temp2
	clrf    Temp3
	clrf	Count
	clrf	Count10
	clrf	Flag
	clrf	Sek_timer
	clrf	ZifferL
	clrf	ZifferR
	movlw	D'20'
	movwf	Int_Count
	bsf		INTCON,T0IE
	bsf		INTCON,GIE


;
;
;******************************************************
;
;       Hauptschleife
;
;       
;       
;       
;
Schleife
	call	Zeige_F60
Segment_Test_Loop
	movlw	D'20'
	movwf	Int_Count
	clrf	Count
	call	Segmenttest
	clrf	Count
	call	Segmenttest
	clrf	Count
	call	Segmenttest
	movlw	Zg			;go anzeigen
	movwf	ZifferL
	movlw	Zo
	movwf	ZifferR	
Warte
	btfsc	Taster
	goto	Warte
	call	Entprell
Warte_LOW
	btfss	Taster
	goto	Warte_LOW
	call	Entprell
	call	Count99
	goto	Warte


;*************************************************************
;		Zeige F 60 auf dem Display
Zeige_F60
	movlw	ZF			;	Ziffer "F"
	movwf	ZifferL
	movlw	ZBlank		;	Ziffer "Blank"
	movwf	ZifferR
	movlw	D'200'
	call	Warte_Delay
	movlw	D'200'
	call	Warte_Delay
	movlw	Z6			;	Ziffer "6"
	movwf	ZifferL
	movlw	Z0			;	Ziffer "0"
	movwf	ZifferR
	movlw	D'200'
	call	Warte_Delay
	movlw	D'200'
	call	Warte_Delay
	movlw	ZBlank		;	Beide Ziffern "Blank"
	movwf	ZifferL
	movwf	ZifferR
	movlw	D'200'
	call	Warte_Delay
	movlw	Z6			;	Ziffer "6"
	movwf	ZifferL
	movlw	Z0			;	Ziffer "0"
	movwf	ZifferR
	movlw	D'200'
	call	Warte_Delay
	movlw	D'200'
	movlw	ZBlank		;	Beide Ziffern "Blank"
	movwf	ZifferL
	movwf	ZifferR
	movlw	D'200'
	call	Warte_Delay
	movlw	Z6			;	Ziffer "6"
	movwf	ZifferL
	movlw	Z0			;	Ziffer "0"
	movwf	ZifferR
	movlw	D'200'
	call	Warte_Delay
	movlw	D'200'
	call	Warte_Delay
	movlw	D'200'
	call	Warte_Delay
	movlw	D'200'
	call	Warte_Delay
	movlw	ZBlank		;	Beide Ziffern "Blank"
	movwf	ZifferR
	movwf	ZifferL
	movlw	D'255'
	call	Warte_Delay

	return

;*************************************************************
;Delay zum Entprellen
Entprell
	clrf    Temp3
	clrf	Temp2
Entprell_not
	decfsz  Temp3
	goto	Entprell_not
	decfsz  Temp2
	goto	Entprell_not
return

;*************************************************************
;	Delay bis Delay- Bit wieder gesetzt ist
Warte_Delay
	movwf	Int_Count
	bcf		Delay
Warte_Delay_Weiter
	btfss	Delay
	goto	Warte_Delay_Weiter
	return


;*************************************************************
;		Ausgabe 0 bis 99 dann wieder Null
Count99
	movlw	ZStrich				;Striche ins Display
	movwf	ZifferL
	movwf	ZifferR
	clrf	Count
	clrf	Count10
	movlw	D'20'			;Geschwingkeit einstellen
	movwf	Int_Count
	BCF		Delay
	movlw	D'10'
	movwf	Temp1
Warte_vor_Random			;10x Delay bis eigentlicher Random
	btfss	Taster			;Taster zu frh gedrckt
	goto	Count99_Fehler
	btfss	Delay
	goto	Warte_vor_Random
	bcf		Delay
	decf	Temp1
	movf	Temp1,w
	bnz		Warte_vor_Random
	movf	Random,w		;Random-Wert fr das Delay
	movwf	Temp1
	BCF		Delay
Warte_Random_Sek
	btfss	Taster			;Taster zu frh gedrckt
	goto	Count99_Fehler
	btfss	Delay
	goto	Warte_Random_Sek
	BCF		Delay
	decf	Temp1
	movf	Temp1,w
	bz		Weiter_Random_Zhlen
	goto	Warte_Random_Sek
Weiter_Random_Zhlen
	movlw	Z0				;Ziffer "00" ausgeben, und dann rennen
	movwf	ZifferL
	movwf	ZifferR
	movlw	D'5'
	movwf	Int_Count	
Count99_Loop
	btfss	Delay			;Delay- Bit gesetzt
	goto	Count99_Loop	;nein, weiter warten
	bcf		Delay			;ja, Bit wieder lschen
	btfss	Taster			;Taster gedrckt?
	goto	Warte_bis_Taste_losgelassen ;Ja: weiter mit Warten auf Taste release
	incf	Count			;Taste nicht gedrckt
	movf	Count,w
	sublw	d'10'			;Zhler bis 10 (grer 9)
	SKPZ
	goto	Kleiner10		;nein, kleiner 10
	clrf	Count			;grer 10, wieder null
	movf	Count,w			;und auch anzeigen
	call	Table_10
	movwf	ZifferR
Zweite_Stelle
	incf	Count10			;zweite Stelle erhhen
	movf	Count10,w		;und mit 10 vergleichen
	sublw	d'10'
	SKPZ	
	goto	Kleiner99		;kleiner "99"
Count99_Fehler
	movlw	Zn				;grer "99" -> "no" ins Display
	movwf	ZifferL
	movlw	Zo
	movwf	ZifferR
	goto	Warte_bis_Taste_losgelassen
Kleiner10					;kleiner 10 -> auf die Anzeige
	movf	Count,w
	call	Table_10
	movwf	ZifferR
	goto	Count99_Loop	;und weiterzhlen
Kleiner99
	movf	Count10,w		;<99 -> Zahl links anzeigen
	call	Table_10
	movwf	ZifferL	
	goto	Count99_Loop
Count_ende
	goto	Count99_ende
Warte_bis_Taste_losgelassen
	call	Entprell
	btfss   Taster
	goto	Warte_bis_Taste_losgelassen
	call	Entprell
Count99_ende
	return


;*************************************************************
;		Segmenttest
Segmenttest
	clrf	Count	
Seqmenttest_Weiter
	btfss	Delay
	goto	Seqmenttest_Weiter
	BCF		Delay
	movf	Count,w
	call	Table_Segment_Test
	movwf	ZifferL
	incf	Count
	movf	Count,w
	call	Table_Segment_Test
	movwf	ZifferR
	incf	Count
	movf	Count,w
	sublw	d'24'
	BZ		Segmenttest_ende
	goto	Seqmenttest_Weiter
Segmenttest_ende
return





org 200h


;
	END
